from ..utils.microservices import Environment
from ..utils.alertEmail import AlertEmail


def alertCrash(func):
    def wrapper(self, *args, **data):
        try:
            func(self, *args, **data)
        except Exception as e:
            AlertEmail.send(
                text="Fix it ASAP!",
                subject="[{environment}] Crash handler: {className}"\
                    .format(**{
                        "environment": Environment.current(),
                        "className": self.__class__.__name__
                    }
                )
            )
            raise e
    return wrapper