from ..models.error import ErrorModel
from ..handlers.base import freeAccessProjectIds


def internalRoute(func):
    def wrapper(self, *args, **data):
        incomingAppId = self.getHeaders().get("X-Appengine-Inbound-Appid")
        if incomingAppId in freeAccessProjectIds:
            return self.sendJson(ErrorModel.new(code=100, message="This is a internal route"))
        return func(self, *args, **data)
    return wrapper