from google.appengine.ext import ndb


class Model(ndb.Model):

    def id(self):
        return str(self.key.id())

    def keyString(self):
        return self.key.urlsafe()

    def delete(self):
        return self.key.delete()

    def parentKey(self):
        return self.key.parent()

    def save(self):
        return self.put()

    @classmethod
    def saveAll(cls, array):
        return ndb.put_multi(array)

    @classmethod
    def deleteAll(cls, array):
        if array.count() == 0: return
        return cls.deleteKeys([key for key in array.iter(keys_only=True)])

    @classmethod
    def deleteKeys(cls, keys):
        return ndb.delete_multi(keys)

    @classmethod
    def getById(cls, id, parentKey=None):
        try:
            return cls.get_by_id(long(id), parent=parentKey) if id.isdigit() else None
        except:
            return None

    @classmethod
    def getByIds(cls, ids):
        return ndb.get_multi([ndb.Key(cls, long(id)) for id in ids])

    @classmethod
    def getByKey(cls, keyString):
        try:
            key = ndb.Key(urlsafe=keyString)
            obj = key.get()
        except:
            return None

        return obj if key and key.kind() == cls.__name__ else None