import random
from ..utils.memcache import Memcache


class Code:

    @classmethod
    def new(cls, key, duration=3600, inf=10012, sup=99988):
        code = str(random.randint(inf, sup))
        Memcache.set(key=key, value=code, time=duration)
        return code

    @classmethod
    def current(cls, key):
        return str(Memcache.get(key=key))

    @classmethod
    def isValid(cls, code, key):
        return cls.current(key) == code

    @classmethod
    def delete(cls, key):
        Memcache.delete(key=key)

    @classmethod
    def numberOfTriesByKey(cls, key):
        currentNumberOfTries = Memcache.get(key=key)
        return 0 if not currentNumberOfTries else currentNumberOfTries

    @classmethod
    def increaseNumberOfTriesByKey(cls, key, duration=3600):
        currentNumberOfTries = Memcache.get(key=key)
        if not currentNumberOfTries:
            Memcache.set(key=key, value=1, time=duration)
        else:
            Memcache.set(key=key, value=currentNumberOfTries+1, time=duration)