import uuid
import hashlib


class Cryptography:

    @classmethod
    def encryptPassword(cls, password):
        salt = uuid.uuid4().hex
        return cls.hashPassword(password, salt) + ':' + salt

    @classmethod
    def verifyPassword(cls, hashedPassword, userPassword):
        password, salt = hashedPassword.split(':')
        return password == cls.hashPassword(userPassword, salt)

    @classmethod
    def hashPassword(cls, password, salt):
        return hashlib.sha256(salt.encode() + password.encode()).hexdigest()
