from ..models.error import ErrorModel


class ErrorResponse:

    def __init__(self, language, messages):
        self.messages = messages
        self.language = language

    def code(self, code, **kwargs):
        message = self.messages.localize(code=code, language=self.language, **kwargs)
        return ErrorModel.new(code=code, message=message)

    def array(self, code, errors, **kwargs):
        message = self.messages.localize(code=code, language=self.language, **kwargs)
        return ErrorModel.array(message=message, code=code, elements=errors)

    def element(self, code, **kwargs):
        message = self.messages.localize(code=code, language=self.language, **kwargs)
        return ErrorModel.element(message=message, code=code)
