import sys
try:
    import requests
except: pass

class Metadata:

    @classmethod
    def getProjectId(cls):
        try:
            from google.appengine.api import app_identity
            return app_identity.get_application_id()
        except ImportError:
            pass
        try:
            url = "http://metadata.google.internal/computeMetadata/v1/project/project-id"
            headers = {"Metadata-Flavor": "Google"}
            return requests.get(url, headers=headers).text
        except requests.exceptions.ConnectionError:
            return [s for s in sys.path[0].split("/") if "ms-" in s][0]
