import json
from google.appengine.api import urlfetch


POST = urlfetch.POST
GET = urlfetch.GET
PUT = urlfetch.PUT
DELETE = urlfetch.DELETE


class Response:

    def __init__(self, content, status, headers):
        self.content = content
        self.status = status
        self.headers= headers

    def contentJson(self):
        return json.loads(self.content)


class Request:

    @classmethod
    def fetch(cls, url, body=None, method=GET, headers=None, deadline=5, validateSSL=False, followRedirects=False):
        response = urlfetch.fetch(
            url=url,
            payload=body,
            method=method,
            headers=headers or {},
            validate_certificate=validateSSL,
            follow_redirects=followRedirects,
            deadline=deadline
        )
        return Response(
            headers=response.headers,
            content=response.content,
            status=response.status_code
        )
